{ mkDerivation
, aeson
, base
, binary
, blaze-html
, containers
, extra
, filepath
, hakyll
, hakyll-contrib-tojnar
, HTTP
, pandoc
, pandoc-types
, text
, warp
, yaml
, lib
}:

let
  # These libraries are still referenced, because they generate
  # a `Paths_*` module for figuring out their version.
  # The `Paths_*` module is generated by Cabal, and contains the
  # version, but also paths to e.g. the data directories, which
  # lead to a transitive runtime dependency on the whole GHC distribution.
  # This should ideally be fixed in haskellPackages.
  disallowedReferences = [
    hakyll
    HTTP
    pandoc
    pandoc-types
    warp
  ];
in
(mkDerivation {
  pname = "wrc2022-rogaining-cz";
  version = "0.0.1";

  # Keep the contents of the src/ directory and top-level .cabal file.
  src = lib.sourceByRegex ./. [ "^src(/.+|$)" "[^/]+\.cabal$" ];

  isLibrary = false;
  isExecutable = true;

  executableHaskellDepends = [
    aeson
    base
    binary
    blaze-html
    containers
    extra
    filepath
    hakyll
    hakyll-contrib-tojnar
    pandoc
    text
    yaml
  ];

  postInstall = ''
    # Pulled in by Paths modules, transitively pulling doc outputs.
    remove-references-to \
      ${lib.concatMapStringsSep " " (ref: ''-t "${ref}"'') disallowedReferences} \
      "$out/bin/site"
  '';

  license = lib.licenses.mit;
}).overrideAttrs (attrs: {
  inherit disallowedReferences;
})
